import { FieldOptions, FieldChangeDto } from '../index';
import { EasyFieldValidator } from '../services/validation.service';
import { Observable } from 'rxjs/Rx';
export declare class EasyField {
    controlType: string;
    value: any;
    selectedItem: any;
    key: any;
    label: string;
    required: boolean;
    order: number;
    hide: boolean;
    columnSpan: number;
    maxLength: number;
    private validators;
    readonly easyValidators: Array<EasyFieldValidator>;
    onEnter: Function;
    updateAction: Function;
    field: this;
    readonly: boolean;
    valid: boolean;
    skipFormValidation: boolean;
    pristine: boolean;
    items: Array<any>;
    action: Function;
    showLoader: boolean;
    hint: string;
    showPaginator: boolean;
    showFilter: boolean;
    url: string;
    xsColumnSize: string;
    smColumnSize: string;
    mdColumnSize: string;
    lgColumnSize: string;
    xlColumnSize: string;
    type: any;
    options: FieldOptions<any>;
    marginLeft?: string;
    marginRight?: string;
    marginTop?: string;
    marginBottom?: string;
    format?: string;
    width?: string;
    minWidth?: string;
    maxWidth?: string;
    textAlign?: string;
    totalItems?: number;
    pageIndex?: number;
    pageSize?: number;
    height?: string;
    minHeight?: string;
    maxHeight?: string;
    allowedExtensions?: string;
    private subject;
    onChange: Observable<EasyField>;
    constructor(options?: FieldOptions<any>);
    addValidator(validator: EasyFieldValidator): void;
    private addAdditionalProprtiesFromValidators();
    valueChanged(event: FieldChangeDto): void;
    static mapFields<T>(dto: T, fields: EasyField[]): void;
}
