import { OnDestroy } from '@angular/core';
import { EasyContainer } from './easyContainer';
import { EasyToolbarContainer, EasyToolbar } from './easyToolbarContainer';
import { EasyCardField } from '../factories/easyCardFactory';
import { EasyExpansionPanelField } from '../factories/easyExpansionPanelFactory';
import { FieldOptions } from '../classes/field-options';
import { EasyTabField } from '../factories/easyTabFactory';
import { EasyStepperField } from '../factories/easyStepperFieldFactory';
import { EasyAccordionField } from '../factories/easyAccordionFactory';
import { EasyButtonField } from '../factories/easyButtonFieldFactory';
import { EasyField } from '../baseClasses/easyField';
export declare class EasyForm implements OnDestroy {
    toolbarContainers: EasyToolbarContainer[];
    private containers;
    private subscriptions;
    fields: Array<EasyField>;
    data: any;
    xsSize: string;
    smSize: string;
    mdSize: string;
    lgSize: string;
    xlSize: string;
    actions: Array<EasyField>;
    layout: string;
    getContainers(): EasyContainer[];
    setSize(size: string): void;
    setLayout(layout: string): void;
    addAction(label: string, action: Function, options?: FieldOptions<any>): EasyButtonField;
    addCardContainer(header: string, options?: FieldOptions<any>): EasyCardField;
    addTabContainer(header: string, options?: FieldOptions<any>): EasyTabField;
    addStepperContainer(header: string, options?: FieldOptions<any>): EasyStepperField;
    addAccordionContainer(header: string, options?: FieldOptions<any>): EasyAccordionField;
    addExpansionPanelContainer(header: string, options?: FieldOptions<any>): EasyExpansionPanelField;
    addModalContainer(header: string, options?: FieldOptions<any>): EasyContainer;
    addToolBarContainer(): EasyToolbar;
    validateForm(): {
        valid: boolean;
        invalidFields: Array<EasyField>;
    };
    validateContainers(containers: EasyContainer[]): EasyField[];
    private addContainer(container);
    private addSubscriptions(fields);
    private addFields(fields);
    mapFields<T>(dto: T): void;
    fetchField(key: string): EasyField;
    fetchFieldValue(key: string): any;
    addField(field: EasyField): void;
    private checkFieldAlreadyExists(key);
    private addSubscription(field);
    private updateField(field);
    setDefaultKey(field: EasyField): void;
    setData(data: any): void;
    enableReadonlyMode(): void;
    disableReadonlyMode(): void;
    ngOnDestroy(): void;
}
