import { DataSource } from '@angular/cdk/table';
import { Observable } from 'rxjs/Observable';
import { MatSort, MatPaginator } from '@angular/material';
import { BehaviorSubject } from 'rxjs/BehaviorSubject';
export declare class TableDatabase {
    dataChange: BehaviorSubject<any[]>;
    readonly data: any[];
    constructor(data: any[]);
}
export declare class TableDataSource extends DataSource<any> {
    private database;
    private sort;
    private columns;
    private paginator;
    filterChange: BehaviorSubject<string>;
    filter: string;
    paginatorInitialized: boolean;
    renderedData: Array<any>;
    displayDataChanges: any;
    constructor(database: TableDatabase, sort: MatSort, columns: string[], paginator: MatPaginator);
    setPaginator(paginator: MatPaginator): void;
    connect(): Observable<Array<any>>;
    disconnect(): void;
    getSortedData(data: Array<any>): any[];
}
