import { OnInit, ElementRef, DoCheck, IterableDiffers, EventEmitter } from '@angular/core';
import { FieldChangeDto } from '../index';
import { EasyField } from '../baseClasses/easyField';
import 'rxjs/add/operator/startWith';
import 'rxjs/add/observable/merge';
import 'rxjs/add/operator/map';
import 'rxjs/add/operator/debounceTime';
import 'rxjs/add/operator/distinctUntilChanged';
import 'rxjs/add/observable/fromEvent';
import { MatSort, Sort, MatSortable, MatPaginator, PageEvent } from '@angular/material';
import { TableDataSource, TableDatabase } from '../common/easy-table-data-source';
export declare class Sortable implements MatSortable {
    id: string;
    start: "asc" | "desc";
    disableClear: boolean;
}
export declare class EasyTableComponent implements OnInit, DoCheck {
    private iterableDiffers;
    columns: Array<EasyField>;
    rows: Array<any>;
    actions: Array<any>;
    showFilter: boolean;
    showPaginator: boolean;
    pageIndex: number;
    pageSize: number;
    totalItems: number;
    displayColumns: Array<string>;
    dataSource: TableDataSource | null;
    database: TableDatabase | null;
    colCounts: number;
    sort: MatSort;
    filter: ElementRef;
    paginator: MatPaginator;
    iterableDiffer: any;
    fieldValueChange: EventEmitter<FieldChangeDto>;
    pageChange: EventEmitter<PageEvent>;
    constructor(iterableDiffers: IterableDiffers);
    ngOnInit(): void;
    ngDoCheck(): void;
    initializeFilter(): void;
    sortData(sort: Sort): void;
    getField(column: EasyField, row: any): EasyField;
    clearFilter(): void;
    click(action: Function, row: any): void;
    rowClicked(row: any): void;
    getValue(column: EasyField, row: {}): any;
    onPageChange(event: PageEvent): void;
}
