import { TableFieldOptions, FieldOptions, EasyDatePickerField, EasySelectField, EasySelectKeyValueField, SelectOption, EasyRadioButtonField, EasyFileUploadField } from '../index';
import { EasyField } from '../baseClasses/easyField';
import { EasyInputField } from '../factories/easyInputFieldFactory';
import { EasyAutocompleteField } from '../factories/easyAutocompleteFieldFactory';
import { EasyAutocompleteKeyValueField } from '../factories/easyAutocompleteKeyValueFieldFactory';
import { EasyCheckboxField } from '../factories/easyCheckBoxFieldFactory';
import { Observable } from 'rxjs/Rx';
import { PageEvent } from '@angular/material';
export declare class EasyTableField extends EasyField {
    controlType: string;
    columns: Array<EasyField>;
    rows: Array<any>;
    actions: Array<EasyField>;
    private pageChangeSubject;
    onPageChange: Observable<EasyTableField>;
    constructor(options?: TableFieldOptions);
    /**
     * @deprecated. Please use addAction.
    */
    addButton(label: string, action: Function, options?: FieldOptions<any>): void;
    addAction(label: string, action: Function, options?: FieldOptions<any>): void;
    addColumn(key: string, label: string, options?: FieldOptions<string>): void;
    addInputField<T>(key: string, label: string, options?: FieldOptions<T>): EasyInputField;
    addSelectField(key: string, label: string, items: Array<string>, options?: FieldOptions<string>): EasySelectField;
    addAutocompleteKeyValueField<T>(key: string, label: string, items: Array<SelectOption<T>>, options?: FieldOptions<T>): EasyAutocompleteKeyValueField<T>;
    addAutocompleteField<T>(key: string, label: string, items: Array<T>, options?: FieldOptions<T>): EasyAutocompleteField;
    addFileUploadField(key: string, label: string, options?: FieldOptions<any>): EasyFileUploadField;
    addCheckboxField(key: string, label: string, options?: FieldOptions<boolean>): EasyCheckboxField;
    addSelectKeyValueField<T>(key: string, label: string, items: Array<SelectOption<T>>, options?: FieldOptions<T>): EasySelectKeyValueField<T>;
    addRadioButtonField<T>(key: string, label: string, items: Array<SelectOption<T>>, options?: FieldOptions<T>): EasyRadioButtonField;
    addDatePickerField(key: string, label: string, options?: FieldOptions<Date>): EasyDatePickerField;
    addTextLabelField(key: string, label: string, options?: FieldOptions<string>): EasyInputField;
    private addField(field);
    private setDefaultKey(field);
    setRows(rows: Array<any>): void;
    addRows(rows: Array<any>): void;
    pageChanged(event: PageEvent): void;
}
