import { OnInit, OnChanges, DoCheck } from '@angular/core';
import { FormControl } from '@angular/forms';
import { EasyField } from '../baseClasses/easyField';
export declare class ValidatorService {
    buildValidators(validators: Array<EasyFieldValidator>, formControl: FormControl): void;
    getError(name: string, validators: Array<EasyFieldValidator>): string;
}
export declare class EasyFormComponent implements OnChanges, OnInit, DoCheck {
    validatorService: ValidatorService;
    validators: Array<EasyFieldValidator>;
    options: any;
    readonly: boolean;
    key: string;
    formControl: FormControl;
    constructor(validatorService: ValidatorService);
    getError(name: string): string;
    ngOnInit(): void;
    ngOnChanges(changes: any): void;
    ngDoCheck(): void;
}
export declare class EasyValidator {
    static Required(message: string): EasyFieldValidator;
    static MinLength(length: number, message: string): EasyFieldValidator;
    static MaxLength(length: number, message: string): EasyFieldValidator;
    static Pattern(pattern: RegExp | string, message: string): EasyFieldValidator;
    static Email(message: string): EasyFieldValidator;
    static TelephoneNumber(message: string): EasyFieldValidator;
    static IdentityNumber(message: string): EasyFieldValidator;
}
export declare class ContainerValidation {
    validateContainerFields(fields: Array<EasyField>): {
        valid: boolean;
        invalidFields: Array<EasyField>;
    };
    private validateTableFields(fields, invalidFields);
    private validateField(field);
    private runFieldValidation(field);
}
export declare class EasyFieldValidator {
    validatorType: ValidatorType;
    message: string;
    maxlength: number;
    minlength: number;
    pattern: RegExp | string;
    requiredValidator(message: string): this;
    maxLengthValidator(length: number, message: string): this;
    minLengthValidator(length: number, message: string): this;
    patternValidator(pattern: RegExp | string, message: string): this;
}
export declare class ValidatorType {
    static required: string;
    static maxlength: string;
    static minlength: string;
    static pattern: string;
}
